import { MatchQuery } from 'src/modules/matcher/queries/match.query';
import { AlgorithmType } from '../../../types/algorithm.enum';
import { AlgorithmFactory } from './algorithm-factory.abstract';
import { ClassicAlgorithmFactory } from './classic';
import { Injectable } from '@nestjs/common';

@Injectable()
export class AlgorithmFactoryCreator {
  create = (matchQuery: MatchQuery): AlgorithmFactory => {
    let algorithm: AlgorithmFactory;
    switch (matchQuery.algorithmSettings.algorithmType) {
      case AlgorithmType.CLASSIC:
        algorithm = new ClassicAlgorithmFactory(matchQuery);
        break;
    }
    return algorithm;
  };
}
